/*-------------------------------------------------------------------*/
/*  FrvMath.h by I. Ferrante, F. Marion, B.Mours  Nov 16, 2001       */
/*-------------------------------------------------------------------*/

#ifndef FRVMATH
#define FRVMATH

#define _POSIX_SOURCE 
#include "FrameL.h"
#include "FrvCopy.h"

#ifdef __cplusplus
extern "C" {
#endif

FrVect *FrvAdd(FrVect *vect1, FrVect *vect2, FrVect *vectOut, char* newName);
FrVect *FrvBias(FrVect *vect1, double bias, FrVect *vectOut);
FrVect *FrvCombine2(double s1, FrVect *vect1,
                    double s2, FrVect *vect2,
                    FrVect *vectOut, char* newName);
FrVect *FrvCombine(int nVect,
                   ...);
int     FrvDelta  (FrVect *vect1, double *delta, double *previous);
FrVect *FrvDivide (FrVect *vect1, FrVect *vect2,FrVect *vectOut,char* newName);
FrVect *FrvFlatten(FrVect *vect1, FrVect *vectOut); 
int     FrvMean   (FrVect *vect1, double *mean);
FrVect *FrvModulus(FrVect *vect1, FrVect *vectOut, char *newName);
FrVect *FrvMult   (FrVect *vect1, FrVect *vect2,FrVect *vectOut,char* newName);
FrVect *FrvMultConj(FrVect *vect1, FrVect *vect2,FrVect *vectOut,char* newName);
FrVect *FrvPhase  (FrVect *vect1, FrVect *vectOut, char *newName);
int     FrvRms    (FrVect *vect1, double *mean, double *rms);
FrVect *FrvScale  (double scale, FrVect *vect1,FrVect *vectOut, char* newName);
FrVect *FrvSub    (FrVect *vect1,FrVect *vect2,FrVect *vectOut, char* newName);
FrVect *FrvZeroMean(FrVect *vect1,FrVect *vectOut); 

#ifdef __cplusplus
}
#endif

#endif
